

#include "colors.inc"
#include "textures.inc"      
#include "consts.inc"
#include "stones.inc" 
#include "glass.inc" 
#include "functions.inc"
#include "sandburger.inc"


#declare r_finerend=1;              //what to render
#declare r_radiosity=0;
#declare r_focus=0;
#declare r_otherplanets=0;
#declare r_athmosphere=0;
#declare r_fakeveget=1;         
#declare r_landsc=1;
#declare r_sand=3;
#declare r_water=1;
#declare r_planet=1;   
#declare r_objects=1;       


#declare p_radius=200000;            //
#declare p_rotation=<0,0,0>;  //dont affects positions of objects!
//#declare cam_zoom=25;
//#declare cam_look=<-16, -13, 0>;  

#declare cam_zoom=1;
#declare cam_look=<1, 2, 0>;  
#declare cam_pos=<0,500,00>;      //top-view
//#declare cam_pos=<0,50,00>;      //top-view close
//#declare cam_pos=<-70, 34, 0>;    //sideview  
#declare cam_pos=<1, 17, -35*1.3>;    //norm-view
#declare vx=vrotate(x,p_rotation); 
#declare vy=vrotate(y,p_rotation); 
#declare vz=vrotate(z,p_rotation); 
#declare p_zerovec=vrotate(<0,p_radius,0>,p_rotation)-<0,p_radius,0>;
#declare px=p_zerovec.x;  
#declare py=p_zerovec.y; 
#declare pz=p_zerovec.z;
#declare s_position=<(534-512)/1.8 ,p_radius+70,(381-190)/1.8>;         
#declare s_ang=-15;         //-72
#declare sx=s_position.x;  
#declare sy=s_position.y; 
#declare sz=s_position.z; 
 
 #declare ts_leafsize=.5;       //initializing Tree Sub Constants
 #declare ts_leaves_br=3;
 #declare ts_treetype=1;
 #declare ts_lengthf=.5;   
 #declare ts_doubranchprob=0;
 #declare ts_gravity=<0,-.02,0>;
 #declare ts_staging=.5;
 #declare ts_angularity=.5;        
 #declare ts_spline=1;
 #declare ts_wood=1; //parse wood            
 
 #declare str_heightfield="..\\terra\\sandb10.png";
 
 #declare r_sunpower=6-3.5*r_athmosphere;     
 

// The Planetfunctions

#if (r_sand)
 #declare fnsand=   // Terrain shape function
  function{ 
    pigment {
    bozo
    turbulence 0.1
    octaves 1
    omega .5
    lambda 1.5
      color_map {
        [0.0 color rgb 0.0]
        [0.3 color rgb 0.2]
        [0.7 color rgb 0.8]
        [1.0 color rgb 1.0]
      }
      scale 1/1025 
      translate <0,0,0>
    }
  }   
#else  
 #declare fnsand=function{ pigment{color rgb 1}}   // Terrain shape function
#end
    #undef fnveg
  #declare fnveg=   // vegetation shape function
  function{ 
    pigment {
    bozo
    turbulence 0.9
    octaves 5
    omega .99
    lambda 3.5
      color_map {
        [0.0 color rgb 0.0]
        [0.4 color rgb 0.3]
        [0.5 color rgb 0.7]
        [1.0 color rgb 1.0]
      }
      scale <.05,1,.05> 
      translate <0,0, 0>
    }
  } 
   
     
     
  #declare fnWat=   // water shape function
  function{
    pigment {
    bozo
    turbulence 0.08
    octaves 5
    omega .4
    lambda 1.5
    color_map {
        [0.0 color rgb 0.0]
        [0.4 color rgb 0.2]
        [0.7 color rgb 0.5]
        [1.0 color rgb 1.0]
    }  scale 2          
      rotate <15,15,15>
      translate <0, 0, 0>
    }
  }
 
          
  #declare fnbugw=function{
  pow(atan(1/sqrt(.0001+pow((x+z*z/3),2)/8+z*z/8)),2)*cos(x+2+z*z/3)*.3}                  //              -(1/sqrt(pow((x+z*z/3),2)/320+z*z/320))
  
  #declare fnheckw=function{
  pow(atan(1/sqrt(.0001+pow((x+abs(z)*3),2)/8+z*z/8)),2)*cos(x+2+abs(z)*3)*.3}  

  #declare fninflator=function{
  pow(atan(1/sqrt(.00001+pow(x/z,2)+pow(y/z,2))),.5)}  
  
  #declare fndeflator=function{
  1-pow(atan(1/sqrt(.00001+pow(x/z,2)+pow(y/z,2))),2)}  
 
  
                       
  #macro positer(vektor)
   #local Norm=<0,0,0>;
   #local vek0=vektor;
   #local vek1=trace(planet,vektor,y,Norm);
   #if (Norm.x != 0 | Norm.y != 0 | Norm.z != 0)
     #declare vek0=vek1;
    #else     
     #local vek1=trace(planet,vektor,-y,Norm);;
     #if (Norm.x != 0 | Norm.y != 0 | Norm.z != 0)
      #local vek0=vek1;
     #else     
      #local vek0=(vek0*2+vektor)/3;
     #end
    #end
   vek0
  #end

//   
 // radiosity (global illumination) settings
global_settings {    
max_trace_level   4+r_athmosphere*5+r_finerend*2+r_otherplanets*2+r_planet+r_objects+r_fakeveget

#if (r_radiosity)
  assumed_gamma 1.5
  radiosity {
    pretrace_start 0.06
    pretrace_end   0.012
    count 150
    always_sample off
    
    nearest_count 8
    error_bound 0.4
    recursion_limit 1

    low_error_factor .4
    gray_threshold 0.0
    minimum_reuse 0.04
    brightness 1
     media on
    adc_bailout 0.05}  }       //.0039
#else 
 adc_bailout 0.05     //.0039
}                         //cam_look+<0,p_radius/8,0>
 light_source { cam_pos-(cam_pos-cam_look)*40, color rgb <1,1,1.1>*(1-.9*r_athmosphere)*1.5
  parallel
  point_at cam_look 
  shadowless
  media_interaction off  
    rotate <60,0,0>   
    //translate <0,p_radius,0>
   }    
#end    


 //sphere{<0, 17, -35>,4}  



camera {                //                The Camera
  
 location cam_pos
  direction <0, 0, 1.5*cam_zoom>
  sky <0,1,0>
  look_at cam_look
  #if (r_focus>0) 
    focal_point cam_look
    blur_samples r_focus+3 
    aperture .1 
    confidence .9
    variance 1/1000 
  #end  
}


 // Light source (Sun)

union{                                             /// union geocentric world       

light_source {
  <0, 1900000,0> color rgb <1.2,1.2,1>*r_sunpower*1.6 
#if (r_finerend>1)  
  area_light  x*16670,y*12000,3,1
  adaptive 0
  //circular                   
  //orient   
  media_attenuation on
#end          
#if (r_athmosphere)
  looks_like{
    sphere { <0,0,0>,1 hollow on                
	interior {    media {method 3	samples 4 intervals 4 scattering {1, color rgb 0.00050 extinction 0} 
			density { spherical } }	} 
    pigment {color rgb 1  transmit 1}
    finish {reflection 0 diffuse 0 ambient 0}   
    scale 20000 }   }
#else
  looks_like{ sphere {<0,0,0>,20000 pigment{rgb <1,.6,.15>*1} finish { ambient 6}}}
  media_interaction off 
  media_attenuation off
#end           


  rotate <58,120,0>            //86//77 61   -35   -10
}
 #declare marble1=union{

   sphere { <0,0,0>, 2 

   interior{    ior 1.5
    caustics 1.0
    media{   method 3 samples 1 intervals 2 scattering {1, color rgb 1 extinction 1} density{rgb .3}}

}
   texture {
       pigment { rgb <1,1,1>*1.5 filter .8 }
       finish {  F_Glass8}                   
       }  
       hollow
  }

  #declare slice1=difference{
    intersection{
     sphere { <-1.8,0,.2>,2.5}
     sphere { <1.8,0,.2>,2.5}
     }
    sphere { <0,0,.35>,1.75}
     interior{I_Glass1}
     scale .8 
   } //slice1
     
   #declare xnum=13;
   #declare xcnt=xnum;
    
   #while (xcnt>0)    
   
    #local redval=.5+sin(pi*4*xcnt/xnum)/2;
    #local greenval=.5+sin(pi*4*(.66+xcnt/xnum))/2;
    #local blueval=.5+sin(pi*4*(1.33+xcnt/xnum))/2;
    
  
    object { slice1  
   
       texture {
       pigment { rgb <redval,greenval,blueval>*1.4 filter .9 }
       finish {  F_Glass8}                   
       }  
       rotate <0,0,15>
       rotate <0,360*xcnt/xnum,0>  

       }
    #declare xcnt=xcnt-1;
   #end
   rotate <-45,8,0>
  translate <0,2,0>
    
                
 }//union marble1

#declare marble2=union{

   sphere { <0,0,0>, 2 

   interior{    ior 1.5
    caustics 1.0
    media{   method 3 samples 1 intervals 2 scattering {1, color rgb 1 extinction 1} density{rgb .3}}

}
   texture {
       pigment { rgb <1,1,1>*1.5 filter .8 }
       finish {  F_Glass8}                   
       } hollow
  }    

     
   #declare xnum=3;
   #declare xcnt=xnum;
    
   #while (xcnt>0)    
   
    #local redval=(.5+cos(pi*2*xcnt/xnum)/2)*1.5;
    #local greenval=(.5+cos(pi*2*(.66+xcnt/xnum))/2)*1.5;
    #local blueval=(.5+cos(pi*2*(1.33+xcnt/xnum))/2)*1.5;
     sphere {<0,0,0>, 1.3+xcnt/10
     hollow  
       interior{    ior 1.5       }

    texture {
    pigment {
    marble
    turbulence 0.7
    octaves 2
    omega .5
    lambda 1.5
      color_map {
        [0.0 color rgbt <1,1,1,1>]
        [0.3 color rgbt <1,1,1,1>]
        [0.7 color rgbt <redval,greenval,blueval,.9>]
        [1.0 color rgbt <redval,greenval,blueval,.7>]
                 }
      scale .5 
      translate <xcnt*5,xcnt+5,xcnt*9>
      #if (xcnt=1)
       rotate <0,0,90>
      #end
      #if (xcnt=2)
       rotate <0,90,0>
      #end
             }//pigment
          
       finish { reflection 0 diffuse .7 ambient .5}                   
       }//texture
    
     }//sphere
  

    #declare xcnt=xcnt-1;
   #end         
   rotate<20,20,20>
  translate <0,2,0>
    
    

}//union marble2

#declare marble3=union{

  sphere { <0,0,0>, 2 

   interior{    ior 1.5
    caustics 1.0
    media{   method 3 samples 1 intervals 2 scattering {1, color rgb 1 extinction 1} density{rgb .3}}

}
   texture {
       pigment { rgb <1,1,1>*1.5 filter .8 }
       finish {  F_Glass8}                   
       }    hollow
   }   
   
   #local tetrang=109.47123;
   #declare tetraeder=intersection{
   plane { -y,.5
   }
   plane { -y,.5
   rotate <tetrang,0,0>
   }
   plane { -y,.5
   rotate <tetrang,120,0>
   }
   plane { -y,.5
   rotate <tetrang,-120,0>
   }
   
   hollow
   interior{    ior 1.5       }
   
   }
  #declare direc=1;
  
  #macro fractaeder(posvec,ttsize,stage)
   #if (stage<1)
    object{tetraeder
     scale ttsize*.66666
     #if (direc<0)
      rotate<180,-60,0>    
     #else 
      rotate <0,60,0> 
     #end 
     translate posvec         
     
      texture {
       pigment { rgb (posvec-direc)/vlength(posvec-direc)*1.5 filter 1 }
       finish {  F_Glass8}                   
       }  }  
   #else
    #local nsize=ttsize/2;              
    #local nstage=stage-1;              
    #local posed1=posvec+<0,nsize,0>*direc;
    #local posed2=posvec+vrotate(<0,nsize,0>,<-tetrang,0,0>)*direc;
    #local posed3=posvec+vrotate(<0,nsize,0>,<-tetrang,-120,0>)*direc;
    #local posed4=posvec+vrotate(<0,nsize,0>,<-tetrang,120,0>)*direc;
    fractaeder(posed1,nsize,nstage)
    fractaeder(posed2,nsize,nstage)
    fractaeder(posed3,nsize,nstage)
    fractaeder(posed4,nsize,nstage)
   #end    
  #end //fractaeder 

  union{
  #declare direc=-1;
  fractaeder(<0,0,0>,2,3)   
  
  #declare direc=1;
  fractaeder(<0,0,0>,2,3)   
   scale <1,.9,1>   
   }            
   rotate <60,45,30>                  
  translate <0,2,0>
    
    

}//union marble3

#declare marble4=union{

   sphere { <0,0,0>, 2 

   interior{    ior 1.5
    caustics 1.0
    media{   method 3 samples 1 intervals 2 scattering {1, color rgb 1 extinction 1} density{rgb .3}}

}
   texture {
       pigment { rgb <1,1,1>*1.5 filter .8 }
       finish {  F_Glass8}                   
       }   hollow
   }   
 #declare fniso1=   // vegetation shape function
  function{ 
    pigment {
    bozo
    turbulence 0.8
    octaves 6
    omega .8
    lambda 1.2
      color_map {
        [0.0 color rgb 0.0]
        [0.7 color rgb 0.3]
        [0.9 color rgb 0.7]
        [1.0 color rgb 1.0]
      }
     scale 1
    }
  } 
 
   
    isosurface {
     function { f_sphere(x, y, z, .5)-fniso1(x, y, z).gray*4 }        
    max_gradient 1//2
    accuracy 0.05//.02
    contained_by { sphere { <0, 0, 0>, 2 } } 
    pigment {   bozo
    turbulence 0.7
    octaves 2
    omega .5
    lambda 1.5
      color_map {
        [0.0 color rgbt <0,0,1,0>]
        [0.1 color rgbt <0,1,1,0>]
        [0.2 color rgbt <0,1,0,0>]
        [0.3 color rgbt <1,1,0,0>]
        [0.4 color rgbt <1,0,0,0>]
        [0.5 color rgbt <1,0,1,0>]
        [0.6 color rgbt <0,0,1,0>]
        [0.7 color rgbt <1,1,0,0>]
        [0.8 color rgbt <0,1,1,0>]
        [0.9 color rgbt <1,0,1,0>]
        [1.0 color rgbt <0,1,0,0>]
             }
        
      scale .5 
      translate <xcnt*5,xcnt+5,xcnt*7>
             }//pigment
 
    finish {phong .4 phong_size 30 reflection .7 diffuse .4 ambient .1 }   
    scale .6
      }       
 
  translate <0,2,0>
    
    

}//union marble4


#declare marble5=union{

   sphere { <0,0,0>, 2 

   interior{    ior 1.5
    caustics 1.0
    media{   method 3 samples 1 intervals 2 scattering {1, color rgb 1 extinction 1} density{rgb .3}}

}
   texture {
       pigment { rgb <1,1,1>*1.5 filter .8 }
       finish {  F_Glass8}                   
       }  hollow
   }   
 #declare fniso2=   // vegetation shape function
  function{ 
    pigment {
    bozo
    turbulence 0.1
    octaves 3
    omega .7
    lambda 1.5
      color_map {
        [0.0 color rgb 0.0]
        [0.6 color rgb 0.3]
        [0.8 color rgb 0.7]
        [1.0 color rgb 1.0]
      }
     scale .5
    }
  } 
 
    isosurface {
     function { f_sphere(x, y, z, .1)-fniso2( atan(x/y)*6 , sqrt(x*x+y*y+z*z)/4 , atan(z/y)*6 ).grey*2.5 } //polar coordinate transforming       
    max_gradient 1//2
    accuracy 0.05//.02
    contained_by { sphere { <0, 0, 0>, 2 } } 
    pigment {   bozo
    turbulence 0.9
    octaves 2
    omega .5
    lambda 1.5
      color_map {
        [0.0 color rgbt <0,0,1,0>]
        [0.1 color rgbt <0,1,1,0>]
        [0.2 color rgbt <0,1,0,0>]
        [0.3 color rgbt <1,1,0,0>]
        [0.4 color rgbt <1,0,0,0>]
        [0.5 color rgbt <1,0,1,0>]
        [0.6 color rgbt <0,0,1,0>]
        [0.7 color rgbt <1,1,0,0>]
        [0.8 color rgbt <0,1,1,0>]
        [0.9 color rgbt <1,0,1,0>]
        [1.0 color rgbt <0,1,0,0>]
             }
        
      scale .5 
                   }//pigment
 
    finish {phong .4 phong_size 30 reflection .7 diffuse .4 ambient .1 }   
    scale .9
      }       
 
  translate <0,2,0>
    
    

}//union marble5



#declare stone1=union{

  #declare fnsiso1=   // shape function
  function{ 
    pigment {
    bozo
    turbulence 0.5
    octaves 3
    omega .3
    lambda 1.2
      color_map {
        [0.0 color rgb 0.0]
        [0.2 color rgb 0.3]
        [0.9 color rgb 0.7]
        [1.0 color rgb 1.0]
      }
     scale 1
    }
  } 
 
   
    isosurface {
     function { f_sphere(x, y, z, .5)-fnsiso1(x, y, z).gray*2 }        
    max_gradient 2//2
    accuracy 0.05//.02
    contained_by { sphere { <0, 0, 0>, 2 } } 
    pigment {   bozo
    turbulence 0.7
    octaves 2
    omega .5
    lambda 1.5
      color_map {
        [0.0 color rgbt <.1,.1,.1,0>]
        [0.4 color rgbt <.2,.2,.15,0>]
        [0.5 color rgbt <.8,.8,.8,0>]
        [0.6 color rgbt <1,1,1,0>]
        [0.7 color rgbt <.9,.9,.9,0>]
        [0.8 color rgbt <.8,.8,.8,0>]
        [0.9 color rgbt <.1,.1,.1,0>]
        [1.0 color rgbt <.1,.1,.1,0>]
             }
        
      scale .5 
             }//pigment
 
    finish {phong 1 phong_size 30 reflection .1 diffuse .8 ambient 0 }      
    normal{bumps 1 scale .002}
    scale .9
      }       
 
  translate <0,1.5,0>
    
    

}//union stone1


#declare stone2=union{

 #declare fnsiso2=   // shape function
  function{ 
    pigment {
    bozo
    turbulence 0.4
    octaves 5
    omega .3
    lambda 1.5
      color_map {
        [0.0 color rgb 0.0]
        [0.2 color rgb 0.3]
        [0.8 color rgb 0.7]
        [1.0 color rgb 1.0]
      }
     scale 1
    }
  } 
 
    isosurface {
     function { f_sphere(x, y, z, .5)-fnsiso2( x,y,z ).grey*2 } //polar coordinate transforming       
    max_gradient 2//2
    accuracy 0.02//.02
    contained_by { sphere { <0, 0, 0>, 2 } }  
    interior{ ior 1.5}
    pigment { bozo
    turbulence 0.9
    octaves 2
    omega .5
    lambda 1.5
      color_map {
        [0.0 color rgbt <.8,.5,.1,0>]
        [0.1 color rgbt <.8,.5,.1,0>*.8]
        [0.2 color rgbt <.8,.5,.1,.5>]
        [0.3 color rgbt <.8,.5,.1,1>]
        [0.4 color rgbt <.8,.5,.1,.7>*.8]
        [0.5 color rgbt <.8,.5,.1,0>*.7]
        [0.6 color rgbt <.8,.5,.1,.6>*.9]
        [0.7 color rgbt <.8,.5,.1,1>]
        [0.8 color rgbt <.8,.5,.1,1>]
        [0.9 color rgbt <.8,.5,.1,.5>*1.1]
        [1.0 color rgbt <.8,.5,.1,0>*1.1]
             }
        
      scale .9 
                   }//pigment
 
    finish {phong 1 phong_size 30 reflection .2 diffuse .6 ambient 0 }   
    scale .9
      }       
 
  translate <0,1.5,0>
    
    

}//union stone2    

#declare stone3=union{

  #declare fnsiso3=   // shape function
  function{ 
    pigment {
    bozo
    turbulence 0.8
    octaves 4
    omega .3
    lambda 1.7
      color_map {
        [0.0 color rgb 0.0]
        [0.2 color rgb 0.3]
        [0.9 color rgb 0.7]
        [1.0 color rgb 1.0]
      }
     scale 1.5
    }
  } 
 
   
    isosurface {
     function { f_sphere(x, y, z, .2)-fnsiso3(x, y, z).gray*3 }        
    max_gradient 2//2
    accuracy 0.05//.02
    contained_by { sphere { <0, 0, 0>, 2 } } 
    pigment {   agate
      color_map {
        [0.0 color rgbt <.1,.1,.1,0>]
        [0.1 color rgbt <.1,.1,.1,0>]
        [0.3 color rgbt <.8,.8,.8,0>]
        [0.5 color rgbt <.9,.9,.9,0>]
        [0.7 color rgbt <1,1,1,0>]
        [0.8 color rgbt <.8,.8,.8,0>]
        [0.9 color rgbt <.2,.2,.15,0>]
        [1.0 color rgbt <.1,.1,.1,0>]
             }
        
      scale 2 
             }//pigment
 
    finish {phong 1 phong_size 30 reflection .05 diffuse .8 ambient 0 }      
    normal{bumps 1 scale .002}
    scale .9
      }       
 
  translate <0,1.5,0>
    
    

}//union stone3


#declare stone4=union{

 #declare fnsiso4=   // shape function
  function{ 
    pigment {
    bozo
    turbulence 0.3
    octaves 3
    omega .2
    lambda 1.5
      color_map {
        [0.0 color rgb 0.0]
        [0.2 color rgb 0.3]
        [0.8 color rgb 0.5]
        [1.0 color rgb 0.8]
      }
     scale 1
    }
  } 
 
    isosurface {
     function { f_sphere(x, y, z, .2)-fnsiso4( x,y,z ).grey*2.7 } //polar coordinate transforming       
    max_gradient 2//2
    accuracy 0.02//.02
    contained_by { sphere { <0, 0, 0>, 2 } }  
    interior{ ior 1.5}
    pigment { agate
    lambda 1.5
      color_map {
        [0.0 color rgbt <.8,.5,.1,0>]
        [0.1 color rgbt <.8,.5,.1,0>*.8]
        [0.2 color rgbt <.8,.5,.1,.5>]
        [0.3 color rgbt <.8,.5,.1,1>]
        [0.4 color rgbt <.8,.5,.1,.7>*.8]
        [0.5 color rgbt <.8,.5,.1,0>*.7]
        [0.6 color rgbt <.8,.5,.1,.6>*.9]
        [0.7 color rgbt <.8,.5,.1,1>]
        [0.8 color rgbt <.8,.5,.1,1>]
        [0.9 color rgbt <.8,.5,.1,.5>*1.1]
        [1.0 color rgbt <.8,.5,.1,0>*1.1]
             }
        
      scale 2.5 
                   }//pigment
 
    finish {phong 1 phong_size 30 reflection .2 diffuse .7 ambient 0 }   
    scale .9
      }       
 
  translate <0,1.3,0>
    
    

}//union stone4

 // #undef fnear

  #declare fnear=   // Terrain shape function
  function{
    #local sam=1/1025;
  pigment {
  average      
  pigment_map{
   [ .06 image_map{png str_heightfield interpolate 4 transmit all 0 filter all 1} rotate <0,0,0> translate <-sam,+sam,0>] 
   [ .06 image_map{png str_heightfield interpolate 4 transmit all 0 filter all 1} rotate <0,0,0> translate <-sam,-sam,0>] 
   [ .06 image_map{png str_heightfield interpolate 4 transmit all 0 filter all 1} rotate <0,0,0> translate <+sam,+sam,0>] 
   [ .06 image_map{png str_heightfield interpolate 4 transmit all 0 filter all 1} rotate <0,0,0> translate <+sam,-sam,0>] 
   [ .12 image_map{png str_heightfield interpolate 4 transmit all 0 filter all 1} rotate <0,0,0> translate <0,+sam,0>] 
   [ .12 image_map{png str_heightfield interpolate 4 transmit all 0 filter all 1} rotate <0,0,0> translate <-sam,0,0>] 
   [ .12 image_map{png str_heightfield interpolate 4 transmit all 0 filter all 1} rotate <0,0,0> translate <+sam,0,0>] 
   [ .12 image_map{png str_heightfield interpolate 4 transmit all 0 filter all 1} rotate <0,0,0> translate <0,-sam,0>] 
   [ .28 image_map{png str_heightfield interpolate 4 transmit all 0 filter all 1} rotate <0,0,0> ] 
   }}
  }      

  #declare fnear2=
  function{
  pigment { image_map{png "../terra/scene2.png" interpolate 4 transmit all 0 filter all 1} }
  }      
  

   
  #declare planet=union{
                  
  union{
 

  #if (r_sand>0)  
 blob{                             //sand
  #declare xcnt=625;
   #while (xcnt>0)     
  #declare ycnt=500;  
  #declare uni=1/150;
  #if (mod(xcnt,10)=0)
    #debug concat("parsing sand castle",str(xcnt,5,0),"\n")
  #end
  #while (ycnt>0)   
   #declare srx=(xcnt)/625+(fnsand(0,ycnt,xcnt).red-.5)/500; 
   #declare sry=(ycnt)/500+(fnsand(xcnt,0,ycnt).blue-.5)/500+mod(xcnt,2)/1000;

   #declare pos3=<srx,fnear(srx,sry,0).gray/20,sry>;
   #if (pos3.y>.02/20)
    #if (r_sand>1)    
     #declare dz1=(fnear(srx+1/500,sry,0).gray/20-fnear(srx-1/500,sry,0).gray/20)/2;
     #declare dz2=(fnear(srx,sry+1/500,0).gray/20-fnear(srx,sry-1/500,0).gray/20)/2;
     #declare xwi=atan(dz1*500)/pi*180;
     #declare ywi=atan(dz2*500)/pi*180;
     sphere{<0,-uni*.75,0>,uni,2
     rotate<ywi,0,xwi>
     translate pos3
     }
     

    
    #else
     sphere{pos3-<0,uni*.75,0>,uni,2}
    #end
   #end
   #declare ycnt=ycnt-1;
  #end 
    #declare xcnt=xcnt-1;
   #end      
    //sturm       
   scale <1,20,1>

  #else
    height_field { png str_heightfield  smooth    
    water_level 0.05

  #end  
      normal { bumps 1 scale <.05/500,.05/200,.05/500>  }  
 pigment { color rgb <0.55,0.5,0.4>}   
  finish { specular .16 diffuse .9 reflection 0.2 }

translate <-.5,-1,-.5>
rotate <3,0,-1>                    
translate <0,1,0>

scale <-50,15,50>
rotate <3,0,0>                    
 translate <0,p_radius-1.30,-3> 
  }     
 
   
#if (r_landsc)    
union{
union{
difference{
intersection{
 box{<0,0,0><1,.21,1>  }
height_field { png "../terra/scene2.png"  smooth    
//        pigment {color rgb 0  transmit 1}
//    finish {reflection 0 diffuse 0 ambient 0} 

  } } //intersection
box{<.355,0,.155><.345+1/6,1,.145+1/6>}}//difference
 

 blob{                               //smooth land
  #declare xcnt=100;
   #while (xcnt>0)     
  #declare ycnt=80;
  #debug concat("  parsing smooth land",str(xcnt,4,0),"\n")
  #while (ycnt>0)   
   #declare srx=.35+xcnt/600; 
   #declare sry=.15+ycnt/480+mod(xcnt,2)/960;
   #declare srx=srx+(fnsand(srx,sry,0).red-.5)/600; 
   #declare sry=sry+(fnsand(srx,sry,0).blue-.5)/600;
   #declare pos3=<srx,fnear2(srx,sry,0).gray/10,sry>;
   #if (pos3.y>.000)
     sphere{pos3-<0,1/1600,0>,1/200,2}
     sphere{pos3+<0,7/1600,0>,1/200,-8}
   #end
   #declare ycnt=ycnt-1;
  #end 
    #declare xcnt=xcnt-1;
   #end            
   scale <1,10,1>
   }    
 
 
  pigment { color rgb <0.55,0.5,0.4>}   
  normal { bumps 1 scale <.05/10000,.05/1000,.05/10000>  }  
  finish { specular .16 diffuse .9 reflection 0.2 }
} 

intersection{

 box{<0,.21,0><1,1,1>      }
height_field { png "../terra/scene2.png"  smooth    
//        pigment {color rgb 0  transmit 1}
//    finish {reflection 0 diffuse 0 ambient 0} 

  }                                      
  pigment { 
  gradient y
  pigment_map{
   [0.0  color rgb <0.55,0.5,0.4>]
   [0.22 color rgb <0.55,0.5,0.4>]
   [0.26 color rgb <.4,.4,.3>*.8]
   [1.0 color rgb <.4,.4,.3>]
   
   } }  
     normal { granite 1 scale <.5/10000,.5/1000,.5/10000>   }  
     finish { specular .16 phong_size 50 diffuse 1.1 }


}//intersection
 
           
               

//translate <-.447,0,-.225>
translate <-.435,0,-.235>
scale <2000,100,2000>
rotate <0,19,0>       
rotate <.17,0,0>             
 translate <0,p_radius-11.5,0> 
      
}//union
#end   
       
  sphere  { <0,0,0>,p_radius-11 

   pigment { color rgb <0.55,0.5,0.4>}   
  normal { bumps 1 scale <.05/10,.05/10,.05/10>  }  
  finish { specular .16 diffuse .9 reflection 0.2 }


  }    
       
        
   } //merge planet     



    // The water surface   
    #if (r_water)
  isosurface {
     function { f_sphere(x, y, z, p_radius-4.90)+(fnbugw((x-sx)/5,y,(z-sz)/10)-fnWat(x, y, z).gray*.5)     } //         
    max_gradient 1.5
    accuracy 0.02
    contained_by { sphere { <0, 0, 0>, p_radius-3.5 } }  
#if (r_finerend)  
    interior{ior Water_Ior
//       media{ method 3 samples 1 intervals 2 scattering {2, color rgb 1 extinction 10} density{rgb 15}}
        fade_distance 1
    fade_power 1601

    }
    pigment { rgb <.15,0.2,.22>*1.5  filter 3}
#else
    pigment { rgb <.15,0.18,.20>*1 filter 3}
#end  
     finish {    
     specular 4
    roughness 0.05
    ambient 0
    diffuse 0.2
    brilliance 4
    reflection {
      0.2, 0.6
      fresnel on   }                   
       } 
    translate -s_position 
    rotate <0,s_ang,0>                           //rotate bug wave to assumed moving direction
    translate s_position

  }              
  #end
   } // union planet   
   
   #if (r_athmosphere) 
// the athmosphere
 sphere { <0,0,0>,1
    hollow on                
  
	interior {
		media {
			method 3 samples 2 intervals 2 scattering {1, color rgb < 0.2, 0.5, 0.8>*0.0002 extinction 0}     ///.005 4  
			density { rgb 1 } 
		}  		

	} 
    pigment {color rgb 0  transmit 1}
    finish {reflection 0 diffuse 0 ambient 0}   
    scale p_radius+5000
}        
// The Clouds    
    sphere { <0,0,0>,1.03
    hollow on                
  
	interior {
		media {
			method 3 samples 2 intervals 9 scattering {2, color rgb .01 extinction 3}                   //.005  7
			density {
						        average
			        density_map{
			        [.70 spherical]
			        [.3        
			        bozo
                                        turbulence 0.5
                                        octaves 5
                                        omega .4 //49876
                                        lambda 4.5 //2.5432
                                        color_map {
                                          [0.0 color rgb 0]    
                                          [0.74 color rgb 0]
                                          [0.85 color rgb .5 ]
                                          [1.0 color rgb 1 ]  
                                          } scale 0.02  scale <1,.4,1> translate <10,0,0>       //.014
    
                                ]}
                                } } 
		}  		
	 
    pigment {color rgb 0  transmit 1}
    finish {reflection 0 diffuse 0 ambient 0}   
    scale p_radius+3000
  }
#else
#include "skies.inc"
sphere{ <0,0,0>,250000
hollow on  
interior { ior 1
//	media { method 3 samples 1 intervals 1 scattering {4, color rgb < 0.2, 0.5, 0.8> extinction 0.00001} density { rgb .01 } }  		
         } 
 
pigment {
        average
        pigment_map {
            [0.4 rgb <0.1, 0.3, 0.85> ]
            [0.5 P_Cloud1 scale 90000 ] 
            [0.2 P_Cloud2 scale 70000 ] 
            [1 P_Cloud3 scale 60000 ] 
                                      
        }
    } finish {reflection 0 diffuse 0 ambient 2} hollow on scale 2}
#end

   
     object{planet} 
     
#if (r_sand>2)                                                   
 blob{                               //sand
  #declare xcnt=800;
   #while (xcnt>0)     
  #declare ycnt=600;
  #if (mod(xcnt,10)=0)
    #debug concat("parsing 'real' sand",str(xcnt,5,0),"\n")
  #end
  #while (ycnt>0)   
   #declare srx=xcnt/800+fnsand(xcnt,ycnt,0).gray/400; 
   #declare sry=ycnt/600+mod(xcnt,2)/1200+fnsand(0,xcnt,ycnt).gray/400;
  #declare pos3=positer(<(.7-srx)*80,p_radius+70,(sry-.4)*80>);
   #if (pos3.y>p_radius-3.5)
    sphere{pos3+<0,1/120,0>,1/60,2}
   #end
   #declare ycnt=ycnt-1;
  #end 
    #declare xcnt=xcnt-1;
   #end            
   
  interior{    ior 1.5 }

  pigment { color rgbt <0.55,.5,.4,.95>}   
  finish { specular .16 diffuse .2 reflection { 0.2, 0.3 fresnel on   } }
  //translate <0,p_radius-2.8,-3> 

}
#end
 
    #if (r_objects) 
     #local pos1=positer(<(503-512)/18 ,p_radius+70,(384-351)/18>);
       object{ marble2 scale .5 translate pos1 }     

     #local pos1=positer(<(524-512)/18 ,p_radius+70,(384-603)/18>);
       object{ marble3 scale .5 translate pos1 }     

     #local pos1=positer(<(680-512)/18 ,p_radius+70,(384-583)/18>);
       object{ marble4 scale .5 translate pos1 }     

     #local pos1=positer(<(370-512)/17 ,p_radius+70,(384-665)/17>);
       object{ marble1 scale .5 translate pos1 }     

     #local pos1=positer(<(438-512)/17 ,p_radius+70,(384-790)/17>);
       object{ marble5 scale .5 translate pos1 }     

     #local pos1=positer(<(500-512)/1.8+1 ,p_radius+70,(381-475)/1.8*1.3>);
       object{ sandburger scale <-1,1,1> scale 110 translate pos1 translate <0,-3,0> }     

     #local pos1=positer(<(739-512)/17 ,p_radius+70,(384-683)/17>);
       object{ stone1 scale .5 translate pos1-<0,.5,0> }     

     #local pos1=positer(<(570-512)/17 ,p_radius+70,(384-762)/17>);
       object{ stone2 scale .5 rotate <00,-15,00> translate pos1  }     

     #local pos1=positer(<(467-512)/17 ,p_radius+70,(384-679)/17>);
       object{ stone3 scale 1 translate pos1-<0,.7,0> }     

     #local pos1=positer(<(289-512)/17 ,p_radius+70,(384-523)/17>);
       object{ stone4 scale .5 translate pos1 }     

    #local pos1=positer(<(670-512)/17 ,p_radius+70,(384-780)/17>);
       object{ stone1 scale .5 rotate <90,90,90> translate pos1-<0,.5,0> }     

     #local pos1=positer(<(900-512)/17 ,p_radius+70,(384-207)/17>);
       object{ stone3 scale .75 rotate <90,90,90> translate pos1-<0,.7,0> }     


    #end
     
#if (r_fakeveget)   
intersection{

     isosurface {
       function { fnveg(x*120, y*6, z*120).gray } //   
    threshold .7
    max_gradient 7//2//7 
    accuracy 0.02 //.02
    contained_by {box{<0,0,0><1,.5,1>}}   
 translate <-.4,0,-.05>
scale <2000,100,2000>
rotate <0,19,0>                    
 translate <0,p_radius-11,0> 
    }

  
blob {     

   #declare xcnt=150;
   #while (xcnt>0)     
  #declare ycnt=60;
  #debug concat("  parsing vegetation",str(xcnt,4,0),"\n")
  #while (ycnt>0)   
   #declare srx=xcnt/150; 
   #declare sry=ycnt/60+mod(xcnt,2)/240;    
   #declare pos2=positer(vrotate(<(sry+.4)*500,p_radius+170,(srx-.1)*1600>,<0,-23,0>));
   #declare pos3=positer(pos2+<fnveg(pos2.x,pos2.y,pos2.z).red*7,170,fnveg(pos2.x,pos2.y,pos2.z).green*15>);
 
   #declare bsize=10-abs(pos3.y-p_radius-9.5)  ;
   #if (bsize>0)
    #declare bsize=bsize*(.1+fnveg(pos2.x,pos2.y,pos2.z).blue);
    sphere{pos3+<0,1+bsize/2,0>,2.5+bsize,1.5}  //bsize*
   #end
   #declare ycnt=ycnt-1;
  #end 
    #declare xcnt=xcnt-1;
   #end 


  }                                      
   texture {
    pigment {
      agate
      color_map {  
 
        [0.0 color rgb <0.2, 0.5, 0.10> ]
        [0.3 color rgb <0.2, 0.6, 0.2> ]
        [0.5 color rgb <0.4, 0.3, 0.05> ]
        [0.7 color rgb <0.4, 0.6, 0.15> ]
        [0.9 color rgb <0.3, 0.7, 0.2> ]
        [1 color rgb <0.05, 0.3, 0.2> ]
      } warp { turbulence 0.9 }
      scale 5 
       }
    finish {
      diffuse 0.7  phong .5 phong_size 230 //0.5
      }
    normal {
      wrinkles 0.6 turbulence 0.9
      scale 0.5
    }  }              


      
}//intersection
#end
   
   
   
    translate <0,-p_radius,0>
 }  //union "geocentric world"
 